SDL_mouse.c File Reference
`#include "../SDL_internal.h"`
`#include "SDL_assert.h"`
`#include "SDL_hints.h"`
`#include "SDL_timer.h"`
`#include "SDL_events.h"`
`#include "SDL_events_c.h"`
`#include "default_cursor.h"`
`#include "../video/SDL_sysvideo.h"`
Include dependency graph for SDL_mouse.c:

Go to the source code of this file.

## Functions

static int | SDL_PrivateSendMouseMotion (SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
int | SDL_MouseInit (void)
void | SDL_SetDefaultCursor (SDL_Cursor *cursor)
SDL_Mouse * | SDL_GetMouse (void)
void | SDL_SetDoubleClickTime (Uint32 interval)
SDL_Window * | SDL_GetMouseFocus (void)
| Get the window which currently has mouse focus. More...
void | SDL_ResetMouse (void)
void | SDL_SetMouseFocus (SDL_Window *window)
static SDL_bool | SDL_UpdateMouseFocus (SDL_Window *window, int x, int y, Uint32 buttonstate)
int | SDL_SendMouseMotion (SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
static SDL_MouseClickState * | GetMouseClickState (SDL_Mouse *mouse, Uint8 button)
int | SDL_SendMouseButton (SDL_Window *window, SDL_MouseID mouseID, Uint8 state, Uint8 button)
int | SDL_SendMouseWheel (SDL_Window *window, SDL_MouseID mouseID, int x, int y, SDL_MouseWheelDirection direction)
void | SDL_MouseQuit (void)
Uint32 | SDL_GetMouseState (int *x, int *y)
| Retrieve the current state of the mouse. More...
Uint32 | SDL_GetRelativeMouseState (int *x, int *y)
| Retrieve the relative state of the mouse. More...
Uint32 | SDL_GetGlobalMouseState (int *x, int *y)
| Get the current state of the mouse, in relation to the desktop. More...
void | SDL_WarpMouseInWindow (SDL_Window *window, int x, int y)
| Moves the mouse to the given position within the window. More...
int | SDL_WarpMouseGlobal (int x, int y)
| Moves the mouse to the given position in global screen space. More...
static SDL_bool | ShouldUseRelativeModeWarp (SDL_Mouse *mouse)
int | SDL_SetRelativeMouseMode (SDL_bool enabled)
| Set relative mouse mode. More...
SDL_bool | SDL_GetRelativeMouseMode ()
| Query whether relative mouse mode is enabled. More...
int | SDL_CaptureMouse (SDL_bool enabled)
| Capture the mouse, to track input outside an SDL window. More...
SDL_Cursor * | SDL_CreateCursor (const Uint8 *data, const Uint8 *mask, int w, int h, int hot_x, int hot_y)
| Create a cursor, using the specified bitmap data and mask (in MSB format). More...
SDL_Cursor * | SDL_CreateColorCursor (SDL_Surface *surface, int hot_x, int hot_y)
| Create a color cursor. More...
SDL_Cursor * | SDL_CreateSystemCursor (SDL_SystemCursor id)
| Create a system cursor. More...
void | SDL_SetCursor (SDL_Cursor *cursor)
| Set the active cursor. More...
SDL_Cursor * | SDL_GetCursor (void)
| Return the active cursor. More...
SDL_Cursor * | SDL_GetDefaultCursor (void)
| Return the default cursor. More...
void | SDL_FreeCursor (SDL_Cursor *cursor)
| Frees a cursor created with SDL_CreateCursor(). More...
int | SDL_ShowCursor (int toggle)
| Toggle whether or not the cursor is shown. More...

## Variables

static SDL_Mouse | SDL_mouse
static Uint32 | SDL_double_click_time = 500
static int | SDL_double_click_radius = 1

## Function Documentation

static SDL_MouseClickState* GetMouseClickState | ( | SDL_Mouse * | mouse,
|  | Uint8 | button
| ) |  |

static

Definition at line 307 of file SDL_mouse.c.

References button, SDL_Mouse::clickstate, i, NULL, SDL_Mouse::num_clickstates, SDL_realloc, and SDL_zero.

Referenced by SDL_SendMouseButton().

{
if (button >= mouse->num_clickstates) {
int i, count = button + 1;
SDL_MouseClickState *clickstate = (SDL_MouseClickState *)SDL_realloc(mouse->clickstate, count * sizeof(*mouse->clickstate));
if (!clickstate) {
return NULL;
}
mouse->clickstate = clickstate;
for (i = mouse->num_clickstates; i < count; ++i) {
SDL_zero(mouse->clickstate[i]);
}
mouse->num_clickstates = count;
}
return &mouse->clickstate[button];
}
button
SDL_Texture * button
Definition: testgamecontroller.c:67
count
GLuint GLuint GLsizei count
Definition: SDL_opengl.h:1564
SDL_Mouse::clickstate
SDL_MouseClickState * clickstate
Definition: SDL_mouse_c.h:89
SDL_Mouse::num_clickstates
int num_clickstates
Definition: SDL_mouse_c.h:88
SDL_realloc
#define SDL_realloc
Definition: SDL_dynapi_overrides.h:382
SDL_zero
#define SDL_zero(x)
Definition: SDL_stdinc.h:357
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_MouseClickState
Definition: SDL_mouse_c.h:36

int SDL_CaptureMouse | ( | SDL_bool | enabled | ) |

Capture the mouse, to track input outside an SDL window.

Parameters

  enabled | Whether or not to enable capturing

Capturing enables your app to obtain mouse events globally, instead of just within your window. Not all video targets support this function. When capturing is enabled, the current window will get all mouse events, but unlike relative mode, no change is made to the cursor and it is not restrained to your window.

This function may also deny mouse input to other windows–both those in your application and others on the system–so you should use this function sparingly, and in small bursts. For example, you might want to track the mouse while the user is dragging something, until the user releases a mouse button. It is not recommended that you capture the mouse for long periods of time, such as the entire time your app is running.

While captured, mouse events still report coordinates relative to the current (foreground) window, but those coordinates may be outside the bounds of the window (including negative values). Capturing is only allowed for the foreground window. If the window loses focus while capturing, the capture will be disabled automatically.

While capturing is enabled, the current window will have the SDL_WINDOW_MOUSE_CAPTURE flag set.

Returns
  0 on success, or -1 if not supported.

Definition at line 628 of file SDL_mouse.c.

References SDL_Mouse::CaptureMouse, SDL_Window::flags, NULL, SDL_GetKeyboardFocus, SDL_GetMouse(), SDL_SetError, SDL_Unsupported, and SDL_WINDOW_MOUSE_CAPTURE.

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Window *focusWindow;
SDL_bool isCaptured;
if (!mouse->CaptureMouse) {
return SDL_Unsupported();
}
focusWindow = SDL_GetKeyboardFocus();
isCaptured = focusWindow && (focusWindow->flags & SDL_WINDOW_MOUSE_CAPTURE);
if (isCaptured == enabled) {
return 0; /* already done! */
}
if (enabled) {
if (!focusWindow) {
return SDL_SetError("No window has focus");
} else if (mouse->CaptureMouse(focusWindow) == -1) {
return -1; /* CaptureMouse() should call SetError */
}
focusWindow->flags |= SDL_WINDOW_MOUSE_CAPTURE;
} else {
if (mouse->CaptureMouse(NULL) == -1) {
return -1; /* CaptureMouse() should call SetError */
}
focusWindow->flags &= ~SDL_WINDOW_MOUSE_CAPTURE;
}
return 0;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_GetKeyboardFocus
#define SDL_GetKeyboardFocus
Definition: SDL_dynapi_overrides.h:222
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:126
SDL_Mouse::CaptureMouse
int(* CaptureMouse)(SDL_Window *window)
Definition: SDL_mouse_c.h:70
SDL_WINDOW_MOUSE_CAPTURE
Definition: SDL_video.h:112
enabled
GLenum GLenum GLsizei const GLuint GLboolean enabled
Definition: SDL_opengl_glext.h:2479
NULL
#define NULL
Definition: begin_code.h:143
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:36
SDL_Window
The type used to identify a window.
Definition: SDL_sysvideo.h:71
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Window::flags
Uint32 flags
Definition: SDL_sysvideo.h:81
SDL_Unsupported
#define SDL_Unsupported()
Definition: SDL_error.h:53

SDL_Cursor* SDL_CreateColorCursor | ( | SDL_Surface * | surface,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Create a color cursor.

See also
  SDL_FreeCursor()

Definition at line 712 of file SDL_mouse.c.

References SDL_Mouse::CreateCursor, cursor, SDL_Mouse::cursors, SDL_Surface::format, SDL_PixelFormat::format, SDL_Surface::h, SDL_Cursor::next, NULL, SDL_ConvertSurfaceFormat, SDL_FreeSurface, SDL_GetMouse(), SDL_PIXELFORMAT_ARGB8888, SDL_SetError, and SDL_Surface::w.

Referenced by SDL_CreateCursor().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Surface *temp = NULL;
SDL_Cursor *cursor;
if (!surface) {
SDL_SetError("Passed NULL cursor surface");
return NULL;
}
if (!mouse->CreateCursor) {
SDL_SetError("Cursors are not currently supported");
return NULL;
}
/* Sanity check the hot spot */
if ((hot_x < 0) || (hot_y < 0) ||
(hot_x >= surface->w) || (hot_y >= surface->h)) {
SDL_SetError("Cursor hot spot doesn't lie within cursor");
return NULL;
}
if (surface->format->format != SDL_PIXELFORMAT_ARGB8888) {
temp = SDL_ConvertSurfaceFormat(surface, SDL_PIXELFORMAT_ARGB8888, 0);
if (!temp) {
return NULL;
}
surface = temp;
}
cursor = mouse->CreateCursor(surface, hot_x, hot_y);
if (cursor) {
cursor->next = mouse->cursors;
mouse->cursors = cursor;
}
SDL_FreeSurface(temp);
return cursor;
}
SDL_PIXELFORMAT_ARGB8888
Definition: SDL_pixels.h:247
SDL_ConvertSurfaceFormat
#define SDL_ConvertSurfaceFormat
Definition: SDL_dynapi_overrides.h:468
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Surface::h
int h
Definition: SDL_surface.h:73
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_Surface::w
int w
Definition: SDL_surface.h:73
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:91
SDL_Mouse::CreateCursor
SDL_Cursor *(* CreateCursor)(SDL_Surface *surface, int hot_x, int hot_y)
Definition: SDL_mouse_c.h:46
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:450
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
NULL
#define NULL
Definition: begin_code.h:143
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:36
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_PixelFormat::format
Uint32 format
Definition: SDL_pixels.h:301

SDL_Cursor* SDL_CreateCursor | ( | const Uint8 * | data,
|  | const Uint8 * | mask,
|  | int | w,
|  | int | h,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Create a cursor, using the specified bitmap data and mask (in MSB format).

The cursor width must be a multiple of 8 bits.

The cursor is created in black and white according to the following:

data | mask | resulting pixel on screen
0 | 1 | White
1 | 1 | Black
0 | 0 | Transparent
1 | 0 | Inverted color if possible, black if not.

See also
  SDL_FreeCursor()

Definition at line 663 of file SDL_mouse.c.

References cursor, NULL, SDL_Surface::pitch, SDL_Surface::pixels, SDL_CreateColorCursor(), SDL_CreateRGBSurface, and SDL_FreeSurface.

{
SDL_Surface *surface;
SDL_Cursor *cursor;
int x, y;
Uint32 *pixel;
Uint8 datab = 0, maskb = 0;
const Uint32 black = 0xFF000000;
const Uint32 white = 0xFFFFFFFF;
const Uint32 transparent = 0x00000000;
/* Make sure the width is a multiple of 8 */
w = ((w + 7) & ~7);
/* Create the surface from a bitmap */
surface = SDL_CreateRGBSurface(0, w, h, 32,
0x00FF0000,
0x0000FF00,
0x000000FF,
0xFF000000);
if (!surface) {
return NULL;
}
for (y = 0; y < h; ++y) {
pixel = (Uint32 *) ((Uint8 *) surface->pixels + y * surface->pitch);
for (x = 0; x < w; ++x) {
if ((x % 8) == 0) {
datab = *data++;
maskb = *mask++;
}
if (maskb & 0x80) {
*pixel++ = (datab & 0x80) ? black : white;
} else {
*pixel++ = (datab & 0x80) ? black : transparent;
}
datab <<= 1;
maskb <<= 1;
}
}
cursor = SDL_CreateColorCursor(surface, hot_x, hot_y);
SDL_FreeSurface(surface);
return cursor;
}
Uint32
uint32_t Uint32
An unsigned 32-bit integer type.
Definition: SDL_stdinc.h:157
SDL_CreateColorCursor
SDL_Cursor * SDL_CreateColorCursor(SDL_Surface *surface, int hot_x, int hot_y)
Create a color cursor.
Definition: SDL_mouse.c:712
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_Cursor
Definition: SDL_mouse_c.h:30
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1967
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_Surface::pixels
void * pixels
Definition: SDL_surface.h:75
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:450
Uint8
uint8_t Uint8
An unsigned 8-bit integer type.
Definition: SDL_stdinc.h:139
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
mask
GLenum GLint GLuint mask
Definition: SDL_opengl_glext.h:657
NULL
#define NULL
Definition: begin_code.h:143
SDL_CreateRGBSurface
#define SDL_CreateRGBSurface
Definition: SDL_dynapi_overrides.h:448
SDL_Surface::pitch
int pitch
Definition: SDL_surface.h:74
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
h
GLfloat GLfloat GLfloat GLfloat h
Definition: SDL_opengl_glext.h:1946

SDL_Cursor* SDL_CreateSystemCursor | ( | SDL_SystemCursor | id | ) |

Create a system cursor.

See also
  SDL_FreeCursor()

Definition at line 755 of file SDL_mouse.c.

References SDL_Mouse::CreateSystemCursor, cursor, SDL_Mouse::cursors, SDL_Cursor::next, NULL, SDL_GetMouse(), and SDL_SetError.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Cursor *cursor;
if (!mouse->CreateSystemCursor) {
SDL_SetError("CreateSystemCursor is not currently supported");
return NULL;
}
cursor = mouse->CreateSystemCursor(id);
if (cursor) {
cursor->next = mouse->cursors;
mouse->cursors = cursor;
}
return cursor;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:91
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
NULL
#define NULL
Definition: begin_code.h:143
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:36
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::CreateSystemCursor
SDL_Cursor *(* CreateSystemCursor)(SDL_SystemCursor id)
Definition: SDL_mouse_c.h:49

void SDL_FreeCursor | ( | SDL_Cursor * | cursor | ) |

Frees a cursor created with SDL_CreateCursor().

See also
  SDL_CreateCursor()

Definition at line 841 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::FreeCursor, SDL_Cursor::next, NULL, SDL_GetMouse(), and SDL_SetCursor().

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Cursor *curr, *prev;
if (!cursor) {
return;
}
if (cursor == mouse->def_cursor) {
return;
}
if (cursor == mouse->cur_cursor) {
SDL_SetCursor(mouse->def_cursor);
}
for (prev = NULL, curr = mouse->cursors; curr;
prev = curr, curr = curr->next) {
if (curr == cursor) {
if (prev) {
prev->next = curr->next;
} else {
mouse->cursors = curr->next;
}
if (mouse->FreeCursor) {
mouse->FreeCursor(curr);
}
return;
}
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:779
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:91
SDL_Mouse::FreeCursor
void(* FreeCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:58
NULL
#define NULL
Definition: begin_code.h:143
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:93
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:92

SDL_Cursor* SDL_GetCursor | ( | void |  | ) |

Return the active cursor.

Definition at line 819 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, NULL, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (!mouse) {
return NULL;
}
return mouse->cur_cursor;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
NULL
#define NULL
Definition: begin_code.h:143
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:93

SDL_Cursor* SDL_GetDefaultCursor | ( | void |  | ) |

Return the default cursor.

Definition at line 830 of file SDL_mouse.c.

References SDL_Mouse::def_cursor, NULL, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (!mouse) {
return NULL;
}
return mouse->def_cursor;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
NULL
#define NULL
Definition: begin_code.h:143
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:92

Uint32 SDL_GetGlobalMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Get the current state of the mouse, in relation to the desktop.

This works just like SDL_GetMouseState(), but the coordinates will be reported relative to the top-left of the desktop. This can be useful if you need to track the mouse outside of a specific window and SDL_CaptureMouse() doesn't fit your needs. For example, it could be useful if you need to track the mouse while dragging a window, where coordinates relative to a window might not be in sync at all times.

Note
  SDL_GetMouseState() returns the mouse position as SDL understands it from the last pump of the event queue. This function, however, queries the OS for the current mouse position, and as such, might be a slightly less efficient function. Unless you know what you're doing and have a good reason to use this function, you probably want SDL_GetMouseState() instead.

Parameters

  x | Returns the current X coord, relative to the desktop. Can be NULL.
  y | Returns the current Y coord, relative to the desktop. Can be NULL.

Returns
  The current button state as a bitmask, which can be tested using the SDL_BUTTON(X) macros.

See also
  SDL_GetMouseState

Definition at line 495 of file SDL_mouse.c.

References SDL_Mouse::GetGlobalMouseState, SDL_assert, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
int tmpx, tmpy;
/* make sure these are never NULL for the backend implementations... */
if (!x) {
x = &tmpx;
}
if (!y) {
y = &tmpy;
}
*x = *y = 0;
if (!mouse->GetGlobalMouseState) {
SDL_assert(0 && "This should really be implemented for every target.");
return 0;
}
return mouse->GetGlobalMouseState(x, y);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Mouse::GetGlobalMouseState
Uint32(* GetGlobalMouseState)(int *x, int *y)
Definition: SDL_mouse_c.h:73
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:167
SDL_Mouse
Definition: SDL_mouse_c.h:43

SDL_Mouse* SDL_GetMouse | ( | void |  | ) |

Definition at line 66 of file SDL_mouse.c.

References SDL_mouse.

Referenced by SDL_CaptureMouse(), SDL_CreateColorCursor(), SDL_CreateSystemCursor(), SDL_FreeCursor(), SDL_GetCursor(), SDL_GetDefaultCursor(), SDL_GetGlobalMouseState(), SDL_GetMouseFocus(), SDL_GetMouseState(), SDL_GetRelativeMouseMode(), SDL_GetRelativeMouseState(), SDL_MouseInit(), SDL_MouseQuit(), SDL_OnWindowFocusGained(), SDL_PrivateSendMouseMotion(), SDL_ResetMouse(), SDL_SendMouseButton(), SDL_SendMouseMotion(), SDL_SendMouseWheel(), SDL_SetCursor(), SDL_SetDefaultCursor(), SDL_SetMouseFocus(), SDL_SetRelativeMouseMode(), SDL_ShowCursor(), SDL_UpdateMouseFocus(), SDL_UpdateWindowGrab(), SDL_WarpMouseGlobal(), and SDL_WarpMouseInWindow().

{
return &SDL_mouse;
}
SDL_mouse
static SDL_Mouse SDL_mouse
Definition: SDL_mouse.c:36

SDL_Window* SDL_GetMouseFocus | ( | void |  | ) |

Get the window which currently has mouse focus.

Definition at line 78 of file SDL_mouse.c.

References SDL_Mouse::focus, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
return mouse->focus;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Mouse
Definition: SDL_mouse_c.h:43

Uint32 SDL_GetMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Retrieve the current state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros, and x and y are set to the mouse cursor position relative to the focus window for the currently selected mouse. You can pass NULL for either x or y.

Definition at line 465 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_Mouse::x, and SDL_Mouse::y.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (x) {
*x = mouse->x;
}
if (y) {
*y = mouse->y;
}
return mouse->buttonstate;
}
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:83
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
SDL_Mouse
Definition: SDL_mouse_c.h:43

SDL_bool SDL_GetRelativeMouseMode | ( | void |  | ) |

Query whether relative mouse mode is enabled.

See also
  SDL_SetRelativeMouseMode()

Definition at line 620 of file SDL_mouse.c.

References SDL_Mouse::relative_mode, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
return mouse->relative_mode;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:84
SDL_Mouse
Definition: SDL_mouse_c.h:43

Uint32 SDL_GetRelativeMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Retrieve the relative state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros, and x and y are set to the mouse deltas since the last call to SDL_GetRelativeMouseState().

Definition at line 479 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_Mouse::xdelta, and SDL_Mouse::ydelta.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (x) {
*x = mouse->xdelta;
}
if (y) {
*y = mouse->ydelta;
}
mouse->xdelta = 0;
mouse->ydelta = 0;
return mouse->buttonstate;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:83
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Mouse::ydelta
int ydelta
Definition: SDL_mouse_c.h:81
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_Mouse::xdelta
int xdelta
Definition: SDL_mouse_c.h:80
SDL_Mouse
Definition: SDL_mouse_c.h:43

int SDL_MouseInit | ( | void |  | ) |

Definition at line 45 of file SDL_mouse.c.

References SDL_Mouse::cursor_shown, SDL_GetMouse(), and SDL_TRUE.

Referenced by SDL_VideoInit().

{
SDL_Mouse *mouse = SDL_GetMouse();
mouse->cursor_shown = SDL_TRUE;
return (0);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:94
SDL_TRUE
Definition: SDL_stdinc.h:129
SDL_Mouse
Definition: SDL_mouse_c.h:43

void SDL_MouseQuit | ( | void |  | ) |

Definition at line 435 of file SDL_mouse.c.

References SDL_Mouse::CaptureMouse, SDL_Mouse::clickstate, cursor, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::FreeCursor, SDL_Cursor::next, SDL_CaptureMouse(), SDL_FALSE, SDL_free(), SDL_FreeCursor(), SDL_GetMouse(), SDL_SetRelativeMouseMode(), SDL_ShowCursor(), and SDL_zerop.

Referenced by SDL_VideoQuit().

{
SDL_Cursor *cursor, *next;
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->CaptureMouse) {
SDL_CaptureMouse(SDL_FALSE);
}
SDL_SetRelativeMouseMode(SDL_FALSE);
SDL_ShowCursor(1);
cursor = mouse->cursors;
while (cursor) {
next = cursor->next;
SDL_FreeCursor(cursor);
cursor = next;
}
if (mouse->def_cursor && mouse->FreeCursor) {
mouse->FreeCursor(mouse->def_cursor);
}
if (mouse->clickstate) {
SDL_free(mouse->clickstate);
}
SDL_zerop(mouse);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::clickstate
SDL_MouseClickState * clickstate
Definition: SDL_mouse_c.h:89
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_ShowCursor
int SDL_ShowCursor(int toggle)
Toggle whether or not the cursor is shown.
Definition: SDL_mouse.c:875
SDL_zerop
#define SDL_zerop(x)
Definition: SDL_stdinc.h:358
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:91
SDL_CaptureMouse
int SDL_CaptureMouse(SDL_bool enabled)
Capture the mouse, to track input outside an SDL window.
Definition: SDL_mouse.c:628
SDL_Mouse::CaptureMouse
int(* CaptureMouse)(SDL_Window *window)
Definition: SDL_mouse_c.h:70
SDL_free
void SDL_free(void *mem)
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
SDL_Mouse::FreeCursor
void(* FreeCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:58
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetRelativeMouseMode
int SDL_SetRelativeMouseMode(SDL_bool enabled)
Set relative mouse mode.
Definition: SDL_mouse.c:571
SDL_FALSE
Definition: SDL_stdinc.h:128
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_FreeCursor
void SDL_FreeCursor(SDL_Cursor *cursor)
Frees a cursor created with SDL_CreateCursor().
Definition: SDL_mouse.c:841
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:92

static int SDL_PrivateSendMouseMotion | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | int | relative,
|  | int | x,
|  | int | y
| ) |  |

static

Definition at line 201 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_Mouse::cur_cursor, SDL_Mouse::cursor_shown, SDL_Window::flags, SDL_Mouse::focus, SDL_Window::id, SDL_Mouse::last_x, SDL_Mouse::last_y, SDL_Mouse::MoveCursor, SDL_Mouse::relative_mode, SDL_Mouse::relative_mode_warp, SDL_ENABLE, SDL_GetEventState, SDL_GetMouse(), SDL_GetWindowSize, SDL_MOUSEMOTION, SDL_PushEvent, SDL_WarpMouseInWindow(), SDL_WINDOW_MOUSE_CAPTURE, SDL_Mouse::x, SDL_Mouse::xdelta, SDL_Mouse::y, and SDL_Mouse::ydelta.

Referenced by SDL_SendMouseMotion(), and SDL_UpdateMouseFocus().

{
SDL_Mouse *mouse = SDL_GetMouse();
int posted;
int xrel;
int yrel;
if (mouse->relative_mode_warp) {
int center_x = 0, center_y = 0;
SDL_GetWindowSize(window, &center_x, &center_y);
center_x /= 2;
center_y /= 2;
if (x == center_x && y == center_y) {
mouse->last_x = center_x;
mouse->last_y = center_y;
return 0;
}
SDL_WarpMouseInWindow(window, center_x, center_y);
}
if (relative) {
xrel = x;
yrel = y;
x = (mouse->last_x + xrel);
y = (mouse->last_y + yrel);
} else {
xrel = x - mouse->last_x;
yrel = y - mouse->last_y;
}
/* Drop events that don't change state */
if (!xrel && !yrel) {
#ifdef DEBUG_MOUSE
printf("Mouse event didn't change state - dropped!\n");
#endif
return 0;
}
/* Update internal mouse coordinates */
if (!mouse->relative_mode) {
mouse->x = x;
mouse->y = y;
} else {
mouse->x += xrel;
mouse->y += yrel;
}
/* make sure that the pointers find themselves inside the windows,
unless we have the mouse captured. */
if (window && ((window->flags & SDL_WINDOW_MOUSE_CAPTURE) == 0)) {
int x_max = 0, y_max = 0;
// !!! FIXME: shouldn't this be (window) instead of (mouse->focus)?
SDL_GetWindowSize(mouse->focus, &x_max, &y_max);
--x_max;
--y_max;
if (mouse->x > x_max) {
mouse->x = x_max;
}
if (mouse->x < 0) {
mouse->x = 0;
}
if (mouse->y > y_max) {
mouse->y = y_max;
}
if (mouse->y < 0) {
mouse->y = 0;
}
}
mouse->xdelta += xrel;
mouse->ydelta += yrel;
/* Move the mouse cursor, if needed */
if (mouse->cursor_shown && !mouse->relative_mode &&
mouse->MoveCursor && mouse->cur_cursor) {
mouse->MoveCursor(mouse->cur_cursor);
}
/* Post the event, if desired */
posted = 0;
if (SDL_GetEventState(SDL_MOUSEMOTION) == SDL_ENABLE) {
SDL_Event event;
event.motion.type = SDL_MOUSEMOTION;
event.motion.windowID = mouse->focus ? mouse->focus->id : 0;
event.motion.which = mouseID;
event.motion.state = mouse->buttonstate;
event.motion.x = mouse->x;
event.motion.y = mouse->y;
event.motion.xrel = xrel;
event.motion.yrel = yrel;
posted = (SDL_PushEvent(&event) > 0);
}
if (relative) {
mouse->last_x = mouse->x;
mouse->last_y = mouse->y;
} else {
/* Use unclamped values if we're getting events outside the window */
mouse->last_x = x;
mouse->last_y = y;
}
return posted;
}
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_Mouse::last_y
int last_y
Definition: SDL_mouse_c.h:82
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::last_x
int last_x
Definition: SDL_mouse_c.h:82
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:83
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Mouse::relative_mode_warp
SDL_bool relative_mode_warp
Definition: SDL_mouse_c.h:85
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_ENABLE
#define SDL_ENABLE
Definition: SDL_events.h:718
SDL_Mouse::ydelta
int ydelta
Definition: SDL_mouse_c.h:81
SDL_WarpMouseInWindow
void SDL_WarpMouseInWindow(SDL_Window *window, int x, int y)
Moves the mouse to the given position within the window.
Definition: SDL_mouse.c:519
SDL_GetWindowSize
#define SDL_GetWindowSize
Definition: SDL_dynapi_overrides.h:531
SDL_WINDOW_MOUSE_CAPTURE
Definition: SDL_video.h:112
SDL_GetEventState
#define SDL_GetEventState(type)
Definition: SDL_events.h:731
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:94
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:84
SDL_PushEvent
#define SDL_PushEvent
Definition: SDL_dynapi_overrides.h:131
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
SDL_MOUSEMOTION
Definition: SDL_events.h:102
SDL_Mouse::xdelta
int xdelta
Definition: SDL_mouse_c.h:80
SDL_Window::id
Uint32 id
Definition: SDL_sysvideo.h:74
SDL_Event
General event structure.
Definition: SDL_events.h:521
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:93
SDL_Window::flags
Uint32 flags
Definition: SDL_sysvideo.h:81
SDL_Mouse::MoveCursor
void(* MoveCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:55

void SDL_ResetMouse | ( | void |  | ) |

Definition at line 86 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_Mouse::focus, i, SDL_Mouse::mouseID, SDL_assert, SDL_BUTTON, SDL_GetMouse(), SDL_RELEASED, and SDL_SendMouseButton().

Referenced by SDL_SetMouseFocus().

{
SDL_Mouse *mouse = SDL_GetMouse();
Uint8 i;
#ifdef DEBUG_MOUSE
printf("Resetting mouse\n");
#endif
for (i = 1; i <= sizeof(mouse->buttonstate)*8; ++i) {
if (mouse->buttonstate & SDL_BUTTON(i)) {
SDL_SendMouseButton(mouse->focus, mouse->mouseID, SDL_RELEASED, i);
}
}
SDL_assert(mouse->buttonstate == 0);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:83
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Mouse::mouseID
SDL_MouseID mouseID
Definition: SDL_mouse_c.h:76
Uint8
uint8_t Uint8
An unsigned 8-bit integer type.
Definition: SDL_stdinc.h:139
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:167
SDL_BUTTON
#define SDL_BUTTON(X)
Definition: SDL_mouse.h:279
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_RELEASED
#define SDL_RELEASED
Definition: SDL_events.h:49
SDL_SendMouseButton
int SDL_SendMouseButton(SDL_Window *window, SDL_MouseID mouseID, Uint8 state, Uint8 button)
Definition: SDL_mouse.c:326

int SDL_SendMouseButton | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | Uint8 | state,
|  | Uint8 | button
| ) |  |

Definition at line 326 of file SDL_mouse.c.

References button, SDL_Mouse::buttonstate, SDL_MouseClickState::click_count, SDL_Mouse::focus, GetMouseClickState(), SDL_Window::id, SDL_MouseClickState::last_timestamp, SDL_MouseClickState::last_x, SDL_MouseClickState::last_y, SDL_abs, SDL_BUTTON, SDL_double_click_radius, SDL_double_click_time, SDL_ENABLE, SDL_GetEventState, SDL_GetMouse(), SDL_GetTicks(), SDL_MOUSEBUTTONDOWN, SDL_MOUSEBUTTONUP, SDL_PRESSED, SDL_PushEvent, SDL_RELEASED, SDL_TICKS_PASSED, SDL_UpdateMouseFocus(), state, SDL_Mouse::x, and SDL_Mouse::y.

Referenced by SDL_BApp::_HandleMouseButton(), and SDL_ResetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
int posted;
Uint32 type;
Uint32 buttonstate = mouse->buttonstate;
SDL_MouseClickState *clickstate = GetMouseClickState(mouse, button);
Uint8 click_count;
/* Figure out which event to perform */
switch (state) {
case SDL_PRESSED:
type = SDL_MOUSEBUTTONDOWN;
buttonstate |= SDL_BUTTON(button);
break;
case SDL_RELEASED:
type = SDL_MOUSEBUTTONUP;
buttonstate &= ~SDL_BUTTON(button);
break;
default:
/* Invalid state -- bail */
return 0;
}
/* We do this after calculating buttonstate so button presses gain focus */
if (window && state == SDL_PRESSED) {
SDL_UpdateMouseFocus(window, mouse->x, mouse->y, buttonstate);
}
if (buttonstate == mouse->buttonstate) {
/* Ignore this event, no state change */
return 0;
}
mouse->buttonstate = buttonstate;
if (clickstate) {
if (state == SDL_PRESSED) {
Uint32 now = SDL_GetTicks();
if (SDL_TICKS_PASSED(now, clickstate->last_timestamp + SDL_double_click_time) ||
SDL_abs(mouse->x - clickstate->last_x) > SDL_double_click_radius ||
SDL_abs(mouse->y - clickstate->last_y) > SDL_double_click_radius) {
clickstate->click_count = 0;
}
clickstate->last_timestamp = now;
clickstate->last_x = mouse->x;
clickstate->last_y = mouse->y;
if (clickstate->click_count < 255) {
++clickstate->click_count;
}
}
click_count = clickstate->click_count;
} else {
click_count = 1;
}
/* Post the event, if desired */
posted = 0;
if (SDL_GetEventState(type) == SDL_ENABLE) {
SDL_Event event;
event.type = type;
event.button.windowID = mouse->focus ? mouse->focus->id : 0;
event.button.which = mouseID;
event.button.state = state;
event.button.button = button;
event.button.clicks = click_count;
event.button.x = mouse->x;
event.button.y = mouse->y;
posted = (SDL_PushEvent(&event) > 0);
}
/* We do this after dispatching event so button releases can lose focus */
if (window && state == SDL_RELEASED) {
SDL_UpdateMouseFocus(window, mouse->x, mouse->y, buttonstate);
}
return posted;
}
SDL_abs
#define SDL_abs
Definition: SDL_dynapi_overrides.h:387
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
button
SDL_Texture * button
Definition: testgamecontroller.c:67
Uint32
uint32_t Uint32
An unsigned 32-bit integer type.
Definition: SDL_stdinc.h:157
SDL_MOUSEBUTTONUP
Definition: SDL_events.h:104
SDL_MouseClickState::last_timestamp
Uint32 last_timestamp
Definition: SDL_mouse_c.h:39
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:83
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
state
struct xkb_state * state
Definition: SDL_waylandsym.h:97
SDL_MOUSEBUTTONDOWN
Definition: SDL_events.h:103
SDL_ENABLE
#define SDL_ENABLE
Definition: SDL_events.h:718
SDL_double_click_radius
static int SDL_double_click_radius
Definition: SDL_mouse.c:38
SDL_MouseClickState::click_count
Uint8 click_count
Definition: SDL_mouse_c.h:40
type
GLuint GLuint GLsizei GLenum type
Definition: SDL_opengl.h:1564
SDL_GetEventState
#define SDL_GetEventState(type)
Definition: SDL_events.h:731
SDL_GetTicks
Uint32 SDL_GetTicks(void)
Get the number of milliseconds since the SDL library initialization.
Uint8
uint8_t Uint8
An unsigned 8-bit integer type.
Definition: SDL_stdinc.h:139
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_PushEvent
#define SDL_PushEvent
Definition: SDL_dynapi_overrides.h:131
SDL_MouseClickState::last_x
int last_x
Definition: SDL_mouse_c.h:38
GetMouseClickState
static SDL_MouseClickState * GetMouseClickState(SDL_Mouse *mouse, Uint8 button)
Definition: SDL_mouse.c:307
SDL_UpdateMouseFocus
static SDL_bool SDL_UpdateMouseFocus(SDL_Window *window, int x, int y, Uint32 buttonstate)
Definition: SDL_mouse.c:140
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
SDL_Window::id
Uint32 id
Definition: SDL_sysvideo.h:74
SDL_BUTTON
#define SDL_BUTTON(X)
Definition: SDL_mouse.h:279
SDL_Event
General event structure.
Definition: SDL_events.h:521
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_MouseClickState::last_y
int last_y
Definition: SDL_mouse_c.h:38
SDL_MouseClickState
Definition: SDL_mouse_c.h:36
SDL_PRESSED
#define SDL_PRESSED
Definition: SDL_events.h:50
SDL_double_click_time
static Uint32 SDL_double_click_time
Definition: SDL_mouse.c:37
SDL_TICKS_PASSED
#define SDL_TICKS_PASSED(A, B)
Compare SDL ticks values, and return true if A has passed B.
Definition: SDL_timer.h:56
SDL_RELEASED
#define SDL_RELEASED
Definition: SDL_events.h:49

int SDL_SendMouseMotion | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | int | relative,
|  | int | x,
|  | int | y
| ) |  |

Definition at line 188 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_PrivateSendMouseMotion(), and SDL_UpdateMouseFocus().

Referenced by SDL_BApp::_HandleMouseMove(), IsSDLWindowEventPending(), and SDL_WarpMouseInWindow().

{
if (window && !relative) {
SDL_Mouse *mouse = SDL_GetMouse();
if (!SDL_UpdateMouseFocus(window, x, y, mouse->buttonstate)) {
return 0;
}
}
return SDL_PrivateSendMouseMotion(window, mouseID, relative, x, y);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_PrivateSendMouseMotion
static int SDL_PrivateSendMouseMotion(SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
Definition: SDL_mouse.c:201
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:83
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_UpdateMouseFocus
static SDL_bool SDL_UpdateMouseFocus(SDL_Window *window, int x, int y, Uint32 buttonstate)
Definition: SDL_mouse.c:140
SDL_Mouse
Definition: SDL_mouse_c.h:43

int SDL_SendMouseWheel | ( | SDL_Window * | window,
|  | SDL_MouseID | mouseID,
|  | int | x,
|  | int | y,
|  | SDL_MouseWheelDirection | direction
| ) |  |

Definition at line 406 of file SDL_mouse.c.

References SDL_Mouse::focus, SDL_Window::id, SDL_ENABLE, SDL_GetEventState, SDL_GetMouse(), SDL_MOUSEWHEEL, SDL_PushEvent, and SDL_SetMouseFocus().

Referenced by SDL_BApp::_HandleMouseWheel().

{
SDL_Mouse *mouse = SDL_GetMouse();
int posted;
if (window) {
SDL_SetMouseFocus(window);
}
if (!x && !y) {
return 0;
}
/* Post the event, if desired */
posted = 0;
if (SDL_GetEventState(SDL_MOUSEWHEEL) == SDL_ENABLE) {
SDL_Event event;
event.type = SDL_MOUSEWHEEL;
event.wheel.windowID = mouse->focus ? mouse->focus->id : 0;
event.wheel.which = mouseID;
event.wheel.x = x;
event.wheel.y = y;
event.wheel.direction = (Uint32)direction;
posted = (SDL_PushEvent(&event) > 0);
}
return posted;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
Uint32
uint32_t Uint32
An unsigned 32-bit integer type.
Definition: SDL_stdinc.h:157
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_ENABLE
#define SDL_ENABLE
Definition: SDL_events.h:718
SDL_SetMouseFocus
void SDL_SetMouseFocus(SDL_Window *window)
Definition: SDL_mouse.c:103
SDL_MOUSEWHEEL
Definition: SDL_events.h:105
SDL_GetEventState
#define SDL_GetEventState(type)
Definition: SDL_events.h:731
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_PushEvent
#define SDL_PushEvent
Definition: SDL_dynapi_overrides.h:131
SDL_Window::id
Uint32 id
Definition: SDL_sysvideo.h:74
SDL_Event
General event structure.
Definition: SDL_events.h:521
SDL_Mouse
Definition: SDL_mouse_c.h:43

void SDL_SetCursor | ( | SDL_Cursor * | cursor | ) |

Set the active cursor.

Definition at line 779 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, cursor, SDL_Mouse::cursor_shown, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::focus, SDL_Cursor::next, NULL, SDL_Mouse::relative_mode, SDL_GetMouse(), SDL_SetError, and SDL_Mouse::ShowCursor.

Referenced by SDL_FreeCursor(), SDL_SetDefaultCursor(), SDL_SetMouseFocus(), SDL_SetRelativeMouseMode(), and SDL_ShowCursor().

{
SDL_Mouse *mouse = SDL_GetMouse();
/* Set the new cursor */
if (cursor) {
/* Make sure the cursor is still valid for this mouse */
if (cursor != mouse->def_cursor) {
SDL_Cursor *found;
for (found = mouse->cursors; found; found = found->next) {
if (found == cursor) {
break;
}
}
if (!found) {
SDL_SetError("Cursor not associated with the current mouse");
return;
}
}
mouse->cur_cursor = cursor;
} else {
if (mouse->focus) {
cursor = mouse->cur_cursor;
} else {
cursor = mouse->def_cursor;
}
}
if (cursor && mouse->cursor_shown && !mouse->relative_mode) {
if (mouse->ShowCursor) {
mouse->ShowCursor(cursor);
}
} else {
if (mouse->ShowCursor) {
mouse->ShowCursor(NULL);
}
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::ShowCursor
int(* ShowCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:52
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:91
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:94
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:84
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
NULL
#define NULL
Definition: begin_code.h:143
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:36
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:93
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:92

void SDL_SetDefaultCursor | ( | SDL_Cursor * | cursor | ) |

Definition at line 55 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, cursor, SDL_Mouse::def_cursor, SDL_GetMouse(), and SDL_SetCursor().

{
SDL_Mouse *mouse = SDL_GetMouse();
mouse->def_cursor = cursor;
if (!mouse->cur_cursor) {
SDL_SetCursor(cursor);
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:779
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:93
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:92

void SDL_SetDoubleClickTime | ( | Uint32 | interval | ) |

Definition at line 72 of file SDL_mouse.c.

References SDL_double_click_time.

{
SDL_double_click_time = interval;
}
SDL_double_click_time
static Uint32 SDL_double_click_time
Definition: SDL_mouse.c:37

void SDL_SetMouseFocus | ( | SDL_Window * | window | ) |

Definition at line 103 of file SDL_mouse.c.

References SDL_Mouse::focus, NULL, SDL_GetMouse(), SDL_ResetMouse(), SDL_SendWindowEvent(), SDL_SetCursor(), SDL_WINDOWEVENT_ENTER, SDL_WINDOWEVENT_LEAVE, and window.

Referenced by SDL_BApp::_HandleMouseFocus(), SDL_DestroyWindow(), SDL_OnWindowFocusGained(), SDL_SendMouseWheel(), SDL_SetRelativeMouseMode(), and SDL_UpdateMouseFocus().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->focus == window) {
return;
}
/* Actually, this ends up being a bad idea, because most operating
systems have an implicit grab when you press the mouse button down
so you can drag things out of the window and then get the mouse up
when it happens. So, #if 0...
*/
#if 0
if (mouse->focus && !window) {
/* We won't get anymore mouse messages, so reset mouse state */
SDL_ResetMouse();
}
#endif
/* See if the current window has lost focus */
if (mouse->focus) {
SDL_SendWindowEvent(mouse->focus, SDL_WINDOWEVENT_LEAVE, 0, 0);
}
mouse->focus = window;
if (mouse->focus) {
SDL_SendWindowEvent(mouse->focus, SDL_WINDOWEVENT_ENTER, 0, 0);
}
/* Update cursor visibility */
SDL_SetCursor(NULL);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
window
SDL_Window * window
Definition: testautomation_render.c:26
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:779
SDL_SendWindowEvent
int SDL_SendWindowEvent(SDL_Window *window, Uint8 windowevent, int data1, int data2)
Definition: SDL_windowevents.c:74
SDL_ResetMouse
void SDL_ResetMouse(void)
Definition: SDL_mouse.c:86
SDL_WINDOWEVENT_LEAVE
Definition: SDL_video.h:154
NULL
#define NULL
Definition: begin_code.h:143
SDL_WINDOWEVENT_ENTER
Definition: SDL_video.h:153
SDL_Mouse
Definition: SDL_mouse_c.h:43

int SDL_SetRelativeMouseMode | ( | SDL_bool | enabled | ) |

Set relative mouse mode.

Parameters

  enabled | Whether or not to enable relative mode

Returns
  0 on success, or -1 if relative mode is not supported.

While the mouse is in relative mode, the cursor is hidden, and the driver will try to report continuous motion in the current window. Only relative motion events will be delivered, the mouse position will not change.

Note
  This function will flush any pending mouse motion.

See also
  SDL_GetRelativeMouseMode()

Definition at line 571 of file SDL_mouse.c.

References SDL_Mouse::focus, SDL_Window::h, NULL, SDL_Mouse::relative_mode, SDL_Mouse::relative_mode_warp, SDL_FALSE, SDL_FlushEvent, SDL_GetKeyboardFocus, SDL_GetMouse(), SDL_MOUSEMOTION, SDL_SetCursor(), SDL_SetMouseFocus(), SDL_TRUE, SDL_UpdateWindowGrab(), SDL_WarpMouseInWindow(), SDL_Mouse::SetRelativeMouseMode, ShouldUseRelativeModeWarp(), SDL_Window::w, SDL_Mouse::x, and SDL_Mouse::y.

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Window *focusWindow = SDL_GetKeyboardFocus();
if (enabled == mouse->relative_mode) {
return 0;
}
if (enabled && focusWindow) {
/* Center it in the focused window to prevent clicks from going through
* to background windows.
*/
SDL_SetMouseFocus(focusWindow);
SDL_WarpMouseInWindow(focusWindow, focusWindow->w/2, focusWindow->h/2);
}
/* Set the relative mode */
if (!enabled && mouse->relative_mode_warp) {
mouse->relative_mode_warp = SDL_FALSE;
} else if (enabled && ShouldUseRelativeModeWarp(mouse)) {
mouse->relative_mode_warp = SDL_TRUE;
} else if (mouse->SetRelativeMouseMode(enabled) < 0) {
if (enabled) {
/* Fall back to warp mode if native relative mode failed */
mouse->relative_mode_warp = SDL_TRUE;
}
}
mouse->relative_mode = enabled;
if (mouse->focus) {
SDL_UpdateWindowGrab(mouse->focus);
/* Put the cursor back to where the application expects it */
if (!enabled) {
SDL_WarpMouseInWindow(mouse->focus, mouse->x, mouse->y);
}
}
/* Flush pending mouse motion - ideally we would pump events, but that's not always safe */
SDL_FlushEvent(SDL_MOUSEMOTION);
/* Update cursor visibility */
SDL_SetCursor(NULL);
return 0;
}
SDL_UpdateWindowGrab
void SDL_UpdateWindowGrab(SDL_Window *window)
Definition: SDL_video.c:2227
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_Window::w
int w
Definition: SDL_sysvideo.h:78
SDL_Mouse::relative_mode_warp
SDL_bool relative_mode_warp
Definition: SDL_mouse_c.h:85
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_FlushEvent
#define SDL_FlushEvent
Definition: SDL_dynapi_overrides.h:126
SDL_Mouse::SetRelativeMouseMode
int(* SetRelativeMouseMode)(SDL_bool enabled)
Definition: SDL_mouse_c.h:67
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:779
SDL_SetMouseFocus
void SDL_SetMouseFocus(SDL_Window *window)
Definition: SDL_mouse.c:103
SDL_GetKeyboardFocus
#define SDL_GetKeyboardFocus
Definition: SDL_dynapi_overrides.h:222
SDL_WarpMouseInWindow
void SDL_WarpMouseInWindow(SDL_Window *window, int x, int y)
Moves the mouse to the given position within the window.
Definition: SDL_mouse.c:519
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:84
SDL_TRUE
Definition: SDL_stdinc.h:129
enabled
GLenum GLenum GLsizei const GLuint GLboolean enabled
Definition: SDL_opengl_glext.h:2479
SDL_Window::h
int h
Definition: SDL_sysvideo.h:78
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
NULL
#define NULL
Definition: begin_code.h:143
SDL_MOUSEMOTION
Definition: SDL_events.h:102
SDL_Window
The type used to identify a window.
Definition: SDL_sysvideo.h:71
SDL_FALSE
Definition: SDL_stdinc.h:128
SDL_Mouse
Definition: SDL_mouse_c.h:43
ShouldUseRelativeModeWarp
static SDL_bool ShouldUseRelativeModeWarp(SDL_Mouse *mouse)
Definition: SDL_mouse.c:551

int SDL_ShowCursor | ( | int | toggle | ) |

Toggle whether or not the cursor is shown.

Parameters

  toggle | 1 to show the cursor, 0 to hide it, -1 to query the current state.

Returns
  1 if the cursor is shown, or 0 if the cursor is hidden.

Definition at line 875 of file SDL_mouse.c.

References SDL_Mouse::cursor_shown, NULL, SDL_FALSE, SDL_GetMouse(), SDL_SetCursor(), and SDL_TRUE.

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_bool shown;
if (!mouse) {
return 0;
}
shown = mouse->cursor_shown;
if (toggle >= 0) {
if (toggle) {
mouse->cursor_shown = SDL_TRUE;
} else {
mouse->cursor_shown = SDL_FALSE;
}
if (mouse->cursor_shown != shown) {
SDL_SetCursor(NULL);
}
}
return shown;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:779
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:126
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:94
SDL_TRUE
Definition: SDL_stdinc.h:129
NULL
#define NULL
Definition: begin_code.h:143
SDL_FALSE
Definition: SDL_stdinc.h:128
SDL_Mouse
Definition: SDL_mouse_c.h:43

static SDL_bool SDL_UpdateMouseFocus | ( | SDL_Window * | window,
|  | int | x,
|  | int | y,
|  | Uint32 | buttonstate
| ) |  |

static

Definition at line 140 of file SDL_mouse.c.

References SDL_Window::flags, SDL_Mouse::focus, SDL_Mouse::mouseID, NULL, SDL_FALSE, SDL_GetMouse(), SDL_GetWindowSize, SDL_PrivateSendMouseMotion(), SDL_SetMouseFocus(), SDL_TRUE, and SDL_WINDOW_MOUSE_CAPTURE.

Referenced by SDL_SendMouseButton(), and SDL_SendMouseMotion().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_bool inWindow = SDL_TRUE;
if (window && ((window->flags & SDL_WINDOW_MOUSE_CAPTURE) == 0)) {
int w, h;
SDL_GetWindowSize(window, &w, &h);
if (x < 0 || y < 0 || x >= w || y >= h) {
inWindow = SDL_FALSE;
}
}
/* Linux doesn't give you mouse events outside your window unless you grab
the pointer.
Windows doesn't give you mouse events outside your window unless you call
SetCapture().
Both of these are slightly scary changes, so for now we'll punt and if the
mouse leaves the window you'll lose mouse focus and reset button state.
*/
#ifdef SUPPORT_DRAG_OUTSIDE_WINDOW
if (!inWindow && !buttonstate) {
#else
if (!inWindow) {
#endif
if (window == mouse->focus) {
#ifdef DEBUG_MOUSE
printf("Mouse left window, synthesizing move & focus lost event\n");
#endif
SDL_PrivateSendMouseMotion(window, mouse->mouseID, 0, x, y);
SDL_SetMouseFocus(NULL);
}
return SDL_FALSE;
}
if (window != mouse->focus) {
#ifdef DEBUG_MOUSE
printf("Mouse entered window, synthesizing focus gain & move event\n");
#endif
SDL_SetMouseFocus(window);
SDL_PrivateSendMouseMotion(window, mouse->mouseID, 0, x, y);
}
return SDL_TRUE;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
SDL_PrivateSendMouseMotion
static int SDL_PrivateSendMouseMotion(SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
Definition: SDL_mouse.c:201
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_SetMouseFocus
void SDL_SetMouseFocus(SDL_Window *window)
Definition: SDL_mouse.c:103
SDL_Mouse::mouseID
SDL_MouseID mouseID
Definition: SDL_mouse_c.h:76
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:126
SDL_GetWindowSize
#define SDL_GetWindowSize
Definition: SDL_dynapi_overrides.h:531
SDL_WINDOW_MOUSE_CAPTURE
Definition: SDL_video.h:112
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_TRUE
Definition: SDL_stdinc.h:129
NULL
#define NULL
Definition: begin_code.h:143
SDL_FALSE
Definition: SDL_stdinc.h:128
SDL_Mouse
Definition: SDL_mouse_c.h:43
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
SDL_Window::flags
Uint32 flags
Definition: SDL_sysvideo.h:81
h
GLfloat GLfloat GLfloat GLfloat h
Definition: SDL_opengl_glext.h:1946

int SDL_WarpMouseGlobal | ( | int | x,
|  | int | y
| ) |  |

Moves the mouse to the given position in global screen space.

Parameters

  x | The x coordinate
  y | The y coordinate

Returns
  0 on success, -1 on error (usually: unsupported by a platform).

Note
  This function generates a mouse motion event

Definition at line 539 of file SDL_mouse.c.

References SDL_GetMouse(), SDL_Unsupported, and SDL_Mouse::WarpMouseGlobal.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->WarpMouseGlobal) {
return mouse->WarpMouseGlobal(x, y);
}
return SDL_Unsupported();
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_Mouse::WarpMouseGlobal
int(* WarpMouseGlobal)(int x, int y)
Definition: SDL_mouse_c.h:64
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Unsupported
#define SDL_Unsupported()
Definition: SDL_error.h:53

void SDL_WarpMouseInWindow | ( | SDL_Window * | window,
|  | int | x,
|  | int | y
| ) |  |

Moves the mouse to the given position within the window.

Parameters

  window | The window to move the mouse into, or NULL for the current mouse focus
  x | The x coordinate within the window
  y | The y coordinate within the window

Note
  This function generates a mouse motion event

Definition at line 519 of file SDL_mouse.c.

References SDL_Mouse::focus, SDL_Mouse::mouseID, NULL, SDL_GetMouse(), SDL_SendMouseMotion(), and SDL_Mouse::WarpMouse.

Referenced by SDL_PrivateSendMouseMotion(), and SDL_SetRelativeMouseMode().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (window == NULL) {
window = mouse->focus;
}
if (window == NULL) {
return;
}
if (mouse->WarpMouse) {
mouse->WarpMouse(window, x, y);
} else {
SDL_SendMouseMotion(window, mouse->mouseID, 0, x, y);
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:66
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Mouse::mouseID
SDL_MouseID mouseID
Definition: SDL_mouse_c.h:76
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
SDL_SendMouseMotion
int SDL_SendMouseMotion(SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
Definition: SDL_mouse.c:188
NULL
#define NULL
Definition: begin_code.h:143
SDL_Mouse::WarpMouse
void(* WarpMouse)(SDL_Window *window, int x, int y)
Definition: SDL_mouse_c.h:61
SDL_Mouse
Definition: SDL_mouse_c.h:43

static SDL_bool ShouldUseRelativeModeWarp | ( | SDL_Mouse * | mouse | ) |

static

Definition at line 551 of file SDL_mouse.c.

References SDL_FALSE, SDL_GetHint, SDL_HINT_MOUSE_RELATIVE_MODE_WARP, SDL_TRUE, and SDL_Mouse::SetRelativeMouseMode.

Referenced by SDL_SetRelativeMouseMode().

{
const char *hint;
if (!mouse->SetRelativeMouseMode) {
return SDL_TRUE;
}
hint = SDL_GetHint(SDL_HINT_MOUSE_RELATIVE_MODE_WARP);
if (hint) {
if (*hint == '0') {
return SDL_FALSE;
} else {
return SDL_TRUE;
}
}
return SDL_FALSE;
}
SDL_Mouse::SetRelativeMouseMode
int(* SetRelativeMouseMode)(SDL_bool enabled)
Definition: SDL_mouse_c.h:67
SDL_GetHint
#define SDL_GetHint
Definition: SDL_dynapi_overrides.h:197
SDL_TRUE
Definition: SDL_stdinc.h:129
SDL_FALSE
Definition: SDL_stdinc.h:128
SDL_HINT_MOUSE_RELATIVE_MODE_WARP
#define SDL_HINT_MOUSE_RELATIVE_MODE_WARP
A variable controlling whether relative mouse mode is implemented using mouse warping.
Definition: SDL_hints.h:244

## Variable Documentation

int SDL_double_click_radius = 1

static

Definition at line 38 of file SDL_mouse.c.

Referenced by SDL_SendMouseButton().

Uint32 SDL_double_click_time = 500

static

Definition at line 37 of file SDL_mouse.c.

Referenced by SDL_SendMouseButton(), and SDL_SetDoubleClickTime().

SDL_Mouse SDL_mouse

static

Definition at line 36 of file SDL_mouse.c.

Referenced by SDL_GetMouse().